---
layout: page
permalink: /contribute/code.html
title: Contribute code
---
## Contributing Code

Cofi is built using **Jetpack Compose**

To fully use **Jetpack Compose** you need [Android Studio Arctic Fox 2020.3.1](https://developer.android.com/studio/preview/features#2020.3.1) or higher.

 **Java 19 is required**

# Bugfixes

Fixing bugs is a great way to get to know source code so if you find any and have spare time to fix them please do open PR so that everyone's morning coffee can get a little bit better. If you can't find any there is a high chance that there is something in [Issues](https://github.com/rozPierog/Cofi/labels/bug)

# Features/Improvements

- If you have an idea for a new feature/improvement:
   - first, open an issue to discuss your idea. I would like to keep Cofi as simple as possible and avoid unnecessary bloat.
- If you don't have any ideas but still want to contribute:
   - First of all: That's the spirit! ☕
   - Look into [Issues](https://github.com/rozPierog/Cofi/issues?q=is%3Aissue+is%3Aopen+label%3Aenhancement) to find unimplemented ideas to be implemented.

# Main Code Coventions

- 100% Kotlin
- 100% Compose for views
- Bleeding edge of Android development
- No internet connection required
- No unnecessary permissions
- No tracking of any kind
- As small as possible
